<template>
  <div class="dialog-box">
    <div
      v-if="commentDisplayable"
      class="body elevation-1"
      :style="{borderColor: borderColor}"
    >
      <span
        class="tip tip-up"
        :style="{borderBottomColor: borderColor}"
      />
      <span
        v-if="ofTutor"
        class="of-tutor"
      >Of tutor: {{ ofTutor }}</span>
      <span class="comment-created">{{ parsedCreated }}</span>
      <div
        v-if="showVisibilityIcon"
        class="visibility-icon"
      >
        <v-tooltip
          v-if="visibleToStudentBool"
          top
          size="20px"
        >
          <template #activator="{ on }">
            <v-icon
              size="20px"
              v-on="on"
            >
              visibility
            </v-icon>
          </template>
          <span>Will be visible to student</span>
        </v-tooltip>
        <v-tooltip
          v-else
          top
        >
          <template #activator="{ on }">
            <v-icon
              size="20px"
              v-on="on"
            >
              visibility_off
            </v-icon>
          </template>
          <span>Won't be visible to student</span>
        </v-tooltip>
      </div>
      <!-- eslint-disable-next-line vue/singleline-html-element-content-newline vue/max-attributes-per-line-->
      <div :key="key" class="message">{{ text }}</div>
      <v-btn
        v-if="deletable"
        text
        icon
        absolute
        class="delete-button"
        @click.stop="toggleDeleteComment"
      >
        <v-icon
          v-if="!markedForDeletion.hasOwnProperty(pk)"
          color="grey darken-1"
          size="20px"
        >
          delete_forever
        </v-icon>
        <v-icon
          v-else
          size="20px"
        >
          restore
        </v-icon>
      </v-btn>
    </div>
    <v-row
      v-if="showLabels && correctorView"
      class="ml-2"
    >
      <v-col sm="4">
        <v-col sm="12">
          CURRENT LABELS
        </v-col>
        <feedback-label
          v-for="label in unchangedLabels"
          :key="label.pk"
          removable
          v-bind="label"
          @remove-clicked="deleteAction"
        />
      </v-col>
      <v-col sm="4">
        <v-col sm="12">
          WILL BE REMOVED
        </v-col>
        <feedback-label
          v-for="label in removedLabels"
          :key="label.pk"
          removable
          v-bind="label"
          @remove-clicked="deleteAction"
        />
      </v-col>
      <v-col sm="4">
        <v-col sm="12">
          WILL BE ADDED
        </v-col>
        <feedback-label
          v-for="label in addedLabels"
          :key="label.pk"
          removable
          v-bind="label"
          @remove-clicked="deleteAction"
        />
      </v-col>
    </v-row>
    <template
      v-if="!correctorView"
      row
      wrap
      align-center
    >
      <v-row
        v-for="label in unchangedLabels"
        :key="label.pk"


        align="center"
      >
        <v-col sm="6">
          <feedback-label
            v-bind="label"
          />
        </v-col>
        <v-col sm="6">
          <span><b>Description: </b>{{ label.description }}</span>
        </v-col>
      </v-row>
    </template>
  </div>
</template>

<script>
import { mapState } from 'vuex'
import { UI } from '@/store/modules/ui'
import { SubmissionNotes, subNotesEventBus } from '@/store/modules/submission-notes'
import FeedbackLabel from '@/components/feedback_labels/FeedbackLabel.vue'
import { FeedbackLabels as Labels } from '@/store/modules/feedback-labels'
import commentLabelSelector from '@/components/mixins/commentLabelSelector'

export default {
  name: 'FeedbackComment',
  components: {
    FeedbackLabel,
  },
  mixins: [
    commentLabelSelector,
  ],
  props: {
    pk: {
      default: '',
      type: String,
      required: false
    },
    text: {
      type: String,
      required: true
    },
    modified: {
      default: '',
      type: String,
      required: false
    },
    ofTutor: {
      default: '',
      type: String,
      required: false
    },
    lineNo: {
      type: String,
      required: true
    },
    deletable: {
      type: Boolean,
      default: false
    },
    visibleToStudentBool: {
      type: Boolean,
      default: true
    },
    showVisibilityIcon: {
      type: Boolean,
      default: true
    },
    correctorView: {
      type: Boolean,
      default: true
    }
  },
  data () {
    return {
      key: 0
    }
  },
  computed: {
    commentDisplayable () { return this.text !== '' },
    showLabels () {
      return this.visibleToStudentBool &&
      (this.getUnchangedLabels().length > 0 ||
       this.getAddedLabels().length > 0 ||
       this.getRemovedLabels().length > 0)
    },
    markedForDeletion () { return SubmissionNotes.state.commentsMarkedForDeletion },
    parsedCreated () {
      if (this.modified) {
        return new Date(this.modified).toLocaleString()
      } else {
        return 'Just now'
      }
    },
    borderColor () {
      if (this.pk) {
        return this.markedForDeletion.hasOwnProperty(this.pk) ? '#B5B5B5' : '#3D8FC1'
      }
      return 'orange'
    },
    unchangedLabels() {
      return this.mapPksToLabelObj(this.getUnchangedLabels())
    },
    addedLabels() {
      return this.mapPksToLabelObj(this.getAddedLabels())
    },
    removedLabels() {
      return this.mapPksToLabelObj(this.getRemovedLabels())
    }
  },
  created() {
    subNotesEventBus.$on('submissionChanged', () => {
      this.key++
    })
    subNotesEventBus.$on('resetSubmission', () => {
      this.key++
    })
  },
  methods: {
    deleteAction (pk) {
      let labels
      const concated = this.getUnchangedLabels().concat(this.getAddedLabels())
      if (this.getUnchangedLabels().includes(pk)) {
        labels = concated.filter((val) => {
          return val !== pk
        })
      } else if (this.getAddedLabels().includes(pk)) {
        labels = concated.filter((val) => {
          return val !== pk
        })
      } else if (this.getRemovedLabels().includes(pk)) {
        concated.push(pk)
        labels = concated
      }

      if (labels.length > 0 || SubmissionNotes.state.hasOrigFeedback || this.commentDisplayable) {
        SubmissionNotes.UPDATE_FEEDBACK_LINE({
          lineNo: Number(this.lineNo),
          comment: {
            text: this.text || '',
            labels: labels,
          }
        })
      } else {
        SubmissionNotes.DELETE_FEEDBACK_LINE(Number(this.lineNo))
      }
    },
    toggleDeleteComment () {
      if (this.pk) {
        if (!this.markedForDeletion.hasOwnProperty(this.pk)) {
          SubmissionNotes.MARK_COMMENT_FOR_DELETION({ pk: this.pk })
        } else {
          SubmissionNotes.UN_MARK_COMMENT_FOR_DELETION({ pk: this.pk })
        }
      }
      SubmissionNotes.DELETE_FEEDBACK_LINE(this.lineNo)
    }
  }
}
</script>

<style scoped>
  .tip {
    width: 0px;
    height: 0px;
    position: absolute;
    background: transparent;
    border: 10px solid;
  }
  .tip-up {
    top: -22px; /* Same as body margin top + border */
    left: 10px;
    border-right-color: transparent;
    border-left-color: transparent;
    border-top-color: transparent;
  }
  .dialog-box .body {
    cursor: pointer;
    position: relative;
    height: auto;
    margin: 20px 10px 10px 10px;
    padding: 5px;
    border-radius: 0px;
    border: 2px solid;
  }
  .body .message {
    white-space: pre-line;
    min-height: 30px;
    border-radius: 3px;
    font-size: 14px;
    line-height: 1.5;
  }
  .delete-button {
    bottom: -12px;
    left: -42px;
  }
  .comment-created {
    position: absolute;
    font-size: 10px;
    right: 4px;
    top: -20px;
  }
  .of-tutor {
    position: absolute;
    font-size: 13px;
    top: -20px;
    left: 50px;
  }
  .visibility-icon {
    position: absolute;
    top: -4px;
    left: -34px;
  }
</style>
